package lapes.ufscar.br.Exemplo01;

import java.util.ArrayList;
import java.util.List;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.support.ui.Select;

public class ExemploWebDriver {
	
	private static WebDriver driver;
	private List<WebElement> elementos;
	private String expressao;
	
	//APENAS PARA SIMULAR SWITCH COM STRINGS
	enum Htmltags {INPUT, TABLE, SELECT};

	public ExemploWebDriver(String pagina, String expressao) {
		try {
			System.setProperty("webdriver.chrome.driver",
					"C:\\Users\\cavamura\\Desktop\\chromedriver_win32\\chromedriver.exe");
			driver = new ChromeDriver();
			//driver.get("http://lcvm.com.br/sistemas/judo/admin/registros/");
			driver.get(pagina);
			this.expressao = expressao;
			Thread.sleep(5000);
		} catch (Exception e) {

		}
	}

	
	/**
	 * WebElement: representa um elemento da página web
	 * 
	 * Alguns métodos:
	 * 
	 *  elemento.getAttribute(); Devolve o valor do atributo.
	 *  elemento.getTagName();   Devolve o nome da tag HTML do elemento.
	 *  elemento.getText();      Devolve o texto presente dentro do elemento.
	 *  elemento.isSelected();   Devolve verdadeiro ou falso se o elemento estiver selecionado ou não.
	 *  elemento.sendKeys();     Insere caracteres no elemento.
	 *  elemento.submit();       Envia dados para o servidor se for um form.
	 *  elemento.clear();        Limpa o conteúdo.
	 *  elemento.click();        Clica e muda o foco para o elemento.
	 *  
	 *  
	 *  
	 *  cxselecao.deselectAll();               Limpa todas as seleções.
	 *  cxselecao.getAllSelectedOptions();     Devolve uma lista com os itens selecionados.
	 *  cxselecao.getOptions();                Devolve uma lista contendo os itens.
	 *  cxselecao.selectByIndex(int index);    Seleciona um item específico dado o índice.
	 *  cxselecao.selectByValue(String value); Seleciona os itens cujo atributo "value" for igual a value.
	 * 
	 */
	public void getElement() {
		WebElement elemento = driver.findElement(By.name("flogin"));
		
	
		System.out.println(elemento.getTagName());
		System.out.println(elemento.getAttribute("name"));
	}
	
	
	/**
	 * xpath
	 * 
	 * - Formato:
	 * 		"//tag[@atributo_da_tag = 'valor_da_tag']" ; Exemplo: //input[@name = 'username']
	 * 
	 * - Acesso às tags:
	 * 		- caminho absoluto : /
	 * 			- tags iguais em um mesmo nível: uso de índice [i]; Exemplo: /html/body/form[1]/input[...
	 *  	- caminho relativo: //; Exemplo: //form[@name='formname']//input[@name='username']
	 *  
	 *  - Operadores:
	 *  	- and, or; Exemplo: //*[@type='submit' or @name='btnReset']
	 *  
	 *  	-content; Exemplo: //*[contains(@name,'btn')]
	 * 
	 */

	public void getAllElements() {
		elementos = driver.findElements(By.xpath("//*"));
		elementos = driver.findElements(By.xpath(expressao));
		this.printElements();
		driver.quit();
	}
	
	public void printElements() {
		for (WebElement x :  elementos) {
			//Htmltags tags = Htmltags.INPUT;
			System.out.println("----------------------------------------------");
			System.out.println("TagName: " + x.getTagName() + " Text: " + x.getText());
			
		    for (Htmltags tg : Htmltags.values()) {
		        if (tg.name().equals(x.getTagName().toUpperCase())) {
					Htmltags tag = Htmltags.valueOf(x.getTagName().toUpperCase());
					switch(tag) {
					case INPUT:
						System.out.println("INPUT type: " + x.getAttribute("type"));
						System.out.println("INPUT name: " + x.getAttribute("name"));
						System.out.println("INPUT id: " + x.getAttribute("id"));
						System.out.println("INPUT value: " + x.getAttribute("value"));
						break;
					case TABLE:
						System.out.println("TABLE: Uma tabela");
						break;
					case SELECT:
						Select cxselecao = new Select(driver.findElement(By.tagName("select")));
						List<WebElement> itens = cxselecao.getOptions();
						for (WebElement y : itens) {
							System.out.println("SELECT Item: " + y.getAttribute("value"));
						}
					}
		        }
		    }
		}
	}

}
